<template>
    <div class="buscador">
        <div class="input-group">
            <input
                type="text"
                @focus="get"
                @blur="onblur"
                class="form-control"
                :placeholder="lang"
                v-model="agency"
            />
            <span class="input-group-addon">
                <i class="zmdi zmdi-search"></i>
            </span>
        </div>
        <div v-if="resultados" class="resultados">
            <template v-if="!message">
                <div class="lista" v-for="a of agencias" :key="a.id">
                    <a href="#" @click="seleccionar(a)">
                        <div class="container row clickable">
                            <div class="col-3">
                                <img :src="a.logo" alt="" class="img-fluid" />
                            </div>
                            <div class="col-9">
                                {{ a.company_name }} <br />
                                {{ a.comercial_name }}
                            </div>
                        </div>
                    </a>
                </div>
            </template>

            <div v-else class="lista">
                <div class="container row align-self-center">
                    <div class="col-3">
                        <i
                            class="zmdi"
                            :class="
                                icon == 2
                                    ? 'zmdi-alert-octagon text-danger'
                                    : 'zmdi-search text-success'
                            "
                            style="font-size: 5ch;"
                        ></i>
                    </div>
                    <div class="col-9">
                        {{ message }}
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    props: ["user", "role", "lang"],
    mounted() {},
    data() {
        return {
            u: this.user,
            r: this.role,
            field: this.lang,
            resultados: false,
            agencias: null,
            message: null,
            icon: null,
            agency: null
        };
    },
    methods: {
        get() {
            this.resultados = true;

            if (!this.agencias) {
                this.icon = 1;
                this.message = "Searching ...";
                axios
                    .get("/api/agency", {
                        params: {
                            assignedToUser: this.u,
                            userHasRole: this.r
                        }
                    })
                    .then(res => {
                        this.message = null;
                        this.agencias = res.data;
                    })
                    .catch(err => {
                        this.icon = 2;
                        this.message = "notfound";
                        console.log(err.response);
                    });
            }
        },
        seleccionar(ag) {
            this.agency = ag.comercial_name + ", " + ag.company_name;
            localStorage.setItem("agency_selected", JSON.stringify(ag));
            this.$emit("select-agency", ag);
        },
        onblur() {
            setTimeout(() => {
                this.resultados = false;
            }, 50);
        }
    }
};
</script>
